# Rate limits and user limits

#### Rest APIs

Aggregated weight limit per minute:

| Starter | Growth | Scale  |
| ------- | ------ | ------ |
| 5000    | 20,000 | 50,000 |

Where all requests have a default weight of 2 points except for the following:

| Endpoint                      | Weight     | Notes                                                                                                         |
| ----------------------------- | ---------- | ------------------------------------------------------------------------------------------------------------- |
| `userPnlSummary`              | 20         |                                                                                                               |
| `userPnlLeaderboard`          | 20         |                                                                                                               |
| `userCompletedTrades`         | 20         |                                                                                                               |
| `userCompletedTradesByTime`   | 20         |                                                                                                               |
| `userFills`                   | 10         |                                                                                                               |
| `userFillsByTime`             | 10         |                                                                                                               |
| `userTwapSliceFills`          | 10         |                                                                                                               |
| `userTwapSummaries`           | 10         |                                                                                                               |
| `userTwapStatusesByTime`      | 20         |                                                                                                               |
| `historicalOrders`            | 10         |                                                                                                               |
| `userFunding`                 | 10         |                                                                                                               |
| `userNonFundingLedgerUpdates` | 10         |                                                                                                               |
| `marketLiquidity`             | 10         |                                                                                                               |
| `builderFills`                | 5          |                                                                                                               |
| `builderFillsByTime`          | 5          |                                                                                                               |
| `builderOrdersByTime`         | 5          |                                                                                                               |
| `fundingHistory`              | 5          |                                                                                                               |
| `portfolioState`              | 5          |                                                                                                               |
| `batchClearinghouseStates`    | 2 per user | Max 100 points. Up to 1000 users (100 with `ALL_DEXES`). Cost multiplied by number of dexes with `ALL_DEXES`. |
| `batchPortfolioStates`        | 3 per user | Max 200 points. Up to 500 users (100 with `ALL_DEXES`). Cost multiplied by number of dexes with `ALL_DEXES`.  |

The [**market data**](/readme/rest-api/market-data.md) **endpoints** (snapshots, l4Book) have their own rate limit and can be called 5 times per 10 minutes. `l4Book` allows 10 requests per 5 minutes.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hydromancer.xyz/readme/rest-api/rate-limits-and-user-limits.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
